
package de.ivu.elect.presentation.person;

import javax.inject.Inject;

import de.ivu.elect.business.person.boundary.PersonendatenConversationSelect;
import de.ivu.elect.business.person.boundary.PersonendatenDateiExportSearchParameters;
import de.ivu.elect.business.person.entity.Personendaten;
import de.ivu.elect.business.person.entity.PersonendatenDateiExportConstants;
import de.ivu.elect.jee.presentation.dynamicform.FormBuilder;
import de.ivu.elect.presentation.person.form.PersonendatenSearchFormBuilder;

public abstract class AbstractCommonPersonendatenDateiExportSearchView extends AbstractPersonendatenDateiExportSearchView {

  private static final long serialVersionUID = 1L;

  @Inject
  protected transient PersonendatenConversationSelect personendatenConversationSelect;

  @Inject
  protected transient PersonendatenSearchFormBuilder personendatenSearchFormBuilder;

  protected AbstractCommonPersonendatenDateiExportSearchView() {
    super();
  }

  public String getPageTitle() {
    return getMessage("entity.search.page.title", getMessage(PersonendatenDateiExportConstants.MESSAGE_KEY_ENTITY_MEHRZAHL));
  }

  public String getPageHeader() {
    return getMessage("entity.search.page.header", getMessage(PersonendatenDateiExportConstants.MESSAGE_KEY_ENTITY_MEHRZAHL));
  }

  @Override
  public void addProperties(FormBuilder formBuilder) {
    PersonendatenDateiExportSearchParameters personendatenDateiExportSearchParameters = getSearchParameters();

    addPersondendatenProperties(formBuilder, personendatenDateiExportSearchParameters);

    if (isPersondendatenSelected()) {
      formBuilder.globalReadonly(); // Bisherige Personendaten nur zur Anzeige!
    }
  }

  protected void addPersondendatenProperties(FormBuilder formBuilder, PersonendatenDateiExportSearchParameters personendatenDateiExportSearchParameters) {
    personendatenSearchFormBuilder.addPersonendatenProperties(formBuilder, personendatenDateiExportSearchParameters);
  }

  protected boolean isPersondendatenSelected() {
    return personendatenConversationSelect.isSelected();
  }

  protected Personendaten getSelectedPersondendaten() {
    return personendatenConversationSelect.getEntity();
  }

  /**
   * @deprecated To be removed...
   * @see AbstractCommonPersonendatenDateiExportSearchView#initSearchParametersByContext
   */
  @Deprecated
  @Override
  public void presetSearchParameters() {
    // To be removed...
  }

  @Override
  protected void initSearchParametersByContext() {
    super.initSearchParametersByContext();

    if (isPersondendatenSelected()) {
      getSearchParameters().setPersonendaten(getSelectedPersondendaten());
    }
  }

  @Override
  public boolean isBtnSearchRendered() {
    return !isPersondendatenSelected();
  }

  @Override
  public boolean isBtnResetRendered() {
    return isBtnSearchRendered();
  }

  @Override
  public boolean isBtnGoBackRendered() {
    return isPersondendatenSelected();
  }
}
